import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:dtu/icons.dart';
import 'package:dtu/widgets/svg_asset.dart';

class DiscoverSmallCard extends StatelessWidget {
  final String? title;
  final String? subtitle;
  final Color? gradientStartColor;
  final Color? gradientEndColor;
  final double? height;
  final double? width;
  final Widget? vectorBottom;
  final Widget? vectorTop;
  final double? borderRadius;
  final Widget? icon;
  final Function? onTap;
  const DiscoverSmallCard(
      {Key? key,
      this.title,
      this.subtitle,
      this.gradientStartColor,
      this.gradientEndColor,
      this.height,
      this.width,
      this.vectorBottom,
      this.vectorTop,
      this.borderRadius,
      this.icon,
      this.onTap})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Material(
      color: Colors.transparent,
      child: InkWell(
        borderRadius: BorderRadius.circular(20),
        onTap: () => onTap!(),
        child: Ink(
          decoration: BoxDecoration(
            borderRadius: BorderRadius.circular(20),
            gradient: LinearGradient(
              colors: [
                gradientStartColor ?? const Color(0xff441DFC),
                gradientEndColor ?? const Color(0xff4E81EB),
              ],
              begin: Alignment.bottomLeft,
              end: Alignment.topRight,
            ),
          ),
          child: Stack(
            children: [
              SizedBox(
                height: 125.w,
                width: 150.w,
              ),
              ClipRRect(
                borderRadius: BorderRadius.circular(20),
                child: SizedBox(
                  height: 125.w,
                  width: 150.w,
                  child: Stack(
                    children: [
                      SizedBox(
                        height: 125.w,
                        width: 150.w,
                        child: const SvgAsset(assetName: AssetName.vectorSmallBottom),
                      ),
                      SizedBox(
                        child: SvgAsset(
                            height: 125.w,
                            width: 150.w,
                            fit: BoxFit.fitHeight,
                            assetName: AssetName.vectorSmallTop),
                      ),
                    ],
                  ),
                ),
              ),
              SizedBox(
                height: 125.w,
                width: 150.w,
                child: Padding(
                  padding: EdgeInsets.only(left: 20.w, top: 20.w, bottom: 20.w),
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                         Text(
                          title!,
                          style: TextStyle(
                              fontSize: 18.w,
                              fontWeight: FontWeight.bold,
                              color: Colors.white),
                        ),
                      Row(
                        children: [
                          icon ??
                              SvgAsset(
                                assetName: AssetName.headphone,
                                height: 24.w,
                                width: 24.w,
                              ),
                        ],
                      )
                    ],
                  ),
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }
}
